﻿Type=StaticCode
Version=2.02
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'DataBase Version 1.5 - August 13th, 2011
	Dim AHM As Int 'THIS IS REQUIRED to determine the number of current fields in the db.Field array
	Dim RecordCount As Int 'Required to hold total number of records
	'These variables can be accessed from all modules and ARE REQUIRED for the database functions.
	'Set the directory, the filename and the database structure. These are all that are required for
	'the database functions. 
	'********************************************************************************************************
	Dim Pointer As Int : Pointer = -1		'Make Record index "Pointer" global and set to -1 no record		*
	Dim FilePath, FileName As String		'Make FilePath & FileName global and set their values           *
	FilePath = File.DirInternal & "/"		'Set the directory												*
	FileName = "mycontacts.dat"				'Datafile name, anything B4A and Android supports				*
	Dim Field(20,2) As String				'Set the Fields Name and Size: Must use Field() as array name	*
	Field(0,0) = "name"		:Field(0,1)=35	'set Field array to max number you will need for any database	*	
	Field(1,0) = "address"	:Field(1,1)=35	'set a null value if the current database does not use all		*
	Field(2,0) = "city"		:Field(2,1)=20	'positions and set 0 as the field length					 	*
	Field(3,0) = "state"	:Field(3,1)=2	'Database sorts by field order. If you want it sorted on 	 	*																*
	Field(4,0) = "zip"		:Field(4,1)=5	'last name, be sure last name is the first field defined. It	*																*
	Field(5,0) = "phone"	:Field(5,1)=14	'sorts on all fields. Field1 & Field2 & Field3, etc.			*
	Field(6,0) = ""			:Field(6,1)=0	'not used for this sample										*
	Field(7,0) = ""			:Field(7,1)=0	'not used for this sample										*
	Field(8,0) = ""			:Field(8,1)=0	'not used for this sample										*
	Field(9,0) = ""			:Field(9,1)=0	'not used for this sample										*
	Field(10,0) = ""		:Field(10,1)=0	'not used for this sample										*
	Field(11,0) = ""		:Field(11,1)=0	'not used for this sample										*
	Field(12,0) = ""		:Field(12,1)=0	'not used for this sample										*
	Field(13,0) = ""		:Field(13,1)=0	'not used for this sample										*
	Field(14,0) = ""		:Field(14,1)=0	'not used for this sample										*
	Field(15,0) = ""		:Field(15,1)=0	'not used for this sample										*
	Field(16,0) = ""		:Field(16,1)=0	'not used for this sample										*
	Field(17,0) = ""		:Field(17,1)=0	'not used for this sample										*	
	Field(18,0) = ""		:Field(18,1)=0	'not used for this sample										*	
	Field(19,0) = ""		:Field(19,1)=0	'not used for this sample										*	
	'********************************************************************************************************
End Sub
'This code goes in a code module named db, short for database functions
'Call any of these from the main with the db. prefix. Examples:
'db.AddRecord() OR db.GetRecords()
Sub Left(Text As String, Length As Long)As String 
	If Length>Text.Length Then Length=Text.Length 
	Return Text.SubString2(0, Length)
End Sub
Sub Right(Text As String, Length As Long) As String
	If Length>Text.Length Then Length=Text.Length 
	Return Text.SubString(Text.Length-Length)
End Sub
Sub Mid(Text As String, Start As Int, Length As Int) As String 
	Return Text.SubString2(Start-1,Start+Length-1)
End Sub
Sub At(Text As String,InStr As String) As String
	Return Text.IndexOf(InStr)
End Sub
Sub Stuff(Text As String, InStr As String, WinStr As String) As String  
	'Stuff("Variable to stuff", "New text to insert", "Text to drop & replace")
	Return Left(Text,At(Text, WinStr)) & InStr & Right(Text, (Len(Text)-At(Text, WinStr))-Len(WinStr))
End Sub
Sub Trim(Text As String) As String
	Return Text.Trim
End Sub
Sub Len(Text As String) As String
	Return Text.Length
End Sub
Sub Ltrim(Text As String) As String
	Do While Left(Text, 1) =" "
		Text = Right(Text, Len(Text)-1)
	Loop
	Return Text
End Sub
Sub Rtrim(Text As String) As String
	Do While Right(Text, 1) =" "
		Text = Left(Text, Len(Text)-1)
	Loop
	Return Text
End Sub
Sub Val(Text As String) As String
	Do While IsNumber(Right(Text,1))=False Then
		If Len(Text) >0 Then
			Text=Left(Text, Len(Text)-1)
		Else
			Exit
		End If	
	Loop
	If Len(Text) > 0 Then 
		Return Text + 0
	Else
		Return 0
	End If	
End Sub
Sub Empty(Text As String) As String
	Text = Trim(Text)
	If Text.Length < 1 Then
		Return True
	Else
		Return False
	End If	
End Sub
Sub iif(Text As String, Text1 As String, Text2 As String) As String
	If Text = True Then Return Text1 Else Return Text2
End Sub
Sub Pause(Tvar As Int)
	Dim Tstart As Long
	Tstart = DateTime.Now
	Do While DateTime.Now-Tstart < (Tvar*1000)
	Loop
End Sub
Sub RndChrGen(Howmany As Int, CT As Int) As String
	a=""
	If CT = 0 Then
		L=65 : U=122
	Else If CT=1 Then
		L=65 : U=90
	Else
		L=97 : U=122
	End If
	For x=1 To Howmany				
		Do While Len(a) < Howmany	
			ha = Rnd(L, U)
			If ha>=91 AND ha<=96 Then 
			Else
				a = a & Chr(ha)
			End If
		Loop
	Next
	Return a
End Sub
Sub Space(HM As Int) As String
	RS = ""
	Do While Len(RS) < HM
		RS = RS & " "
	Loop
	Return RS
End Sub
Sub ActiveFields As Int
	StrVar = ""
	AHM=0
	Do While Field(AHM,1) > 0
		AHM = AHM +1
	Loop
	Return AHM
End Sub
Sub GetStructure()
	StrVar = ""
	For l = 0 To ActiveFields -1
		StrVar = StrVar & "Field:" & (l+1) & " - "
		StrVar = StrVar & Field(l,1) & iif(l = Field.Length -1,"",", ")
	Next
	Msgbox(StrVar,"Current Active DataBase Structure:")	
End Sub
Sub GenerateRecords(Howmany)
	ToastMessageShow("No Records in System, Generating " & Howmany & " records, please wait...", True)
	Dim MyList As List
    MyList.Initialize
	Dim AF As String
	AF = ""
	For l = 1 To Howmany
		For fl = 0 To ActiveFields -1
			AF = AF & RndChrGen(Field(fl,1),2) 
		Next
		MyList.Add(AF)
		AF = ""
	Next
	RecordCount = MyList.Size
	File.WriteList(FilePath, FileName, MyList)
	MyList.Clear
End Sub
Sub ListRecords(Title As String, Wfield As Int) As Int
	If Exist(FilePath&FileName) Then
		If Wfield < 1 OR Wfield >  ActiveFields Then
			Wfield = 1
			ToastMessageShow("Invalid field number passed, reset to field 1", False)
		End If	
		Dim MyList As List
    	MyList = File.ReadList(FilePath, FileName)
		RecordCount = MyList.Size
		Dim showlist(MyList.Size) As String
		Vstart=0
		For cl = 0 To Wfield-2
			Vstart = Vstart + Field(cl,1)
		Next 
		For l = 0 To MyList.Size -1
			showlist(l) = Mid(MyList.Get(l), (Vstart+1), Field(Wfield-1,1))
		Next
		ANS = InputList(showlist, Title, 0)
		If ANS = DialogResponse.CANCEL Then
			ToastMessageShow("User Canceled", False)
			Return
		End If
		MyList.Clear
		Pointer = ANS
		GetRecord
	Else
		ToastMessageShow("File Not Found Or No Records", False)
	End If
End Sub
Sub AddRecord()
	ToastMessageShow("Record Added", False)
	Dim MyList As List
    MyList.Initialize
	If Exist(FilePath&FileName) Then
		MyList = File.ReadList(FilePath, FileName)
	End If
	CallSub(Main, "PutFields")
	Dim AF As String
	AF = ""
	For fl = 0 To ActiveFields -1
		AF = AF & Left(Trim(Field(fl,0)) & Space(Field(fl,1)-Len(Trim(Field(fl,0)))), Field(fl,1))
	Next
	MyList.Add(AF)
	MySearch=Trim(Left(AF, Field(0,1)))
	RecordCount = MyList.Size
	MyList.SortCaseInsensitive(True)
	File.WriteList(FilePath, FileName, MyList)
	MyList.Clear
	FindRecord(MySearch)
End Sub
Sub UpdateRecord()
	If Exist(FilePath&FileName) Then
		CallSub(Main, "PutFields")
		Dim MyList As List
	    MyList.Initialize
		MyList = File.ReadList(FilePath, FileName)
		If MyList.Size < 1 Then
			MyList.Clear
			ToastMessageShow("DataBase Empty, Click Add to Insert New Records", False)
			Return
		End If
		ToastMessageShow("Record Updated", False)
		Dim AF As String
		AF = ""
		For fl = 0 To ActiveFields -1
			AF = AF & Left(Trim(Field(fl,0)) & Space(Field(fl,1)-Len(Trim(Field(fl,0)))), Field(fl,1))
		Next
		MyList.Set(Pointer, AF)
		MySearch=Left(AF, Field(0,1))
		MyList.SortCaseInsensitive(True)
		RecordCount = MyList.Size
		File.WriteList(FilePath, FileName, MyList)
		MyList.Clear
		FindRecord(MySearch)
	Else
		ToastMessageShow("File Not Found Or No Records", False)
	End If
End Sub
Sub DeleteRecord()
	If Exist(FilePath&FileName) Then
		Dim MyList As List
    	MyList.Initialize
		MyList = File.ReadList(FilePath, FileName)
		If MyList.Size < 1 Then
			MyList.Clear
			ToastMessageShow("DataBase is Empty", False)
			Return
		End If	
		If Msgbox2("Please Confirm Your Choice?", "Delete Record For: " & Field(0,0),"Yes", "", "No", Null) = DialogResponse.POSITIVE Then
    	Else
    		Return
    	End If
		ToastMessageShow("Record Deleted", False)
		MyList.RemoveAt(Pointer)
		RecordCount = MyList.Size
		File.WriteList(FilePath, FileName, MyList)
		If MyList.Size > 0 Then
			If Pointer < MyList.Size -1 Then
			Else
				Pointer = MyList.Size -1
			End If
		Else
			ToastMessageShow("DataBase is Empty", False)
			MyList.Clear
			Return
		End If
		MyList.Clear
		GetRecord
	Else
		ToastMessageShow("File Not Found Or No Records", False)
	End If
End Sub
Sub GetRecord()
	If Exist(FilePath&FileName) Then
		Dim MyList As List
	    MyList = File.ReadList(FilePath, FileName)
		RecordCount = MyList.Size
		If MyList.Size < 1 Then
			MyList.Clear
			ToastMessageShow("DataBase Empty, Click Add to Insert New Records", False)
			Return
		End If
		AF = MyList.Get(Pointer)
		VEnd = 0
		For l = 0 To ActiveFields -1
			VEnd = VEnd + Field(l,1)
			VLen = Field(l,1)
			VStart = (VEnd - Field(l,1)) +1
			Field(l,0) = Trim(Mid(AF, VStart, VLen))
		Next
		MyList.Clear
		CallSub(Main, "GetFields")
	Else
		ToastMessageShow("File Not Found Or No Records", False)
		CallSub(Main, "ClearFields")
	End If
End Sub
Sub Exist(Text As String) As Boolean
	If File.Exists("", Text) Then Return True Else Return False
End Sub
Sub FindRecord(SearchStr As String)
	If Exist(FilePath&FileName) Then
		Dim MyList As List
		SearchStr = Trim(SearchStr.ToLowerCase)
	    MyList = File.ReadList(FilePath, FileName)
		RecordCount = MyList.Size
		Dim StrToSch As String
		RPF = -1
		For l = 0 To MyList.Size -1
			StrToSch=MyList.Get(l)
			StrToSch=StrToSch.ToLowerCase
			RPF = At(StrToSch, SearchStr)
			If RPF > -1 Then
				RPF = l
				Pointer = RPF
				GetRecord
				Return
			End If
		Next
		ToastMessageShow("No Match Was Found", False)
	Else
		ToastMessageShow("File Not Found Or No Records", False)
	End If
End Sub
Sub FirstRecord()
	If Exist(FilePath&FileName) Then
		Dim MyList As List
    	MyList = File.ReadList(FilePath, FileName)
		RecordCount = MyList.Size
		If MyList.Size > 0 Then
			Pointer = 0
			GetRecord
		End If
	Else
		ToastMessageShow("File Not Found Or No Records", False)
	End If
End Sub
Sub LastRecord()
	If Exist(FilePath&FileName) Then
		Dim MyList As List
    	MyList = File.ReadList(FilePath, FileName)
		RecordCount = MyList.Size
		If MyList.Size > 0 Then
			Pointer = MyList.Size -1
			GetRecord
		End If
	Else
		ToastMessageShow("File Not Found Or No Records", False)
	End If
End Sub
Sub PreviousRecord()
	If Exist(FilePath&FileName) Then
		Dim MyList As List
    	MyList = File.ReadList(FilePath, FileName)
		RecordCount = MyList.Size
		If Pointer > 0 Then
			Pointer = Pointer -1
			GetRecord
		Else
			ToastMessageShow("No More Records, Beginning Of File", False)
		End If
	Else
		ToastMessageShow("File Not Found Or No Records", False)
	End If
End Sub
Sub NextRecord()
	If Exist(FilePath&FileName) Then
		Dim MyList As List
    	MyList = File.ReadList(FilePath, FileName)
		RecordCount = MyList.Size
		If Pointer < MyList.Size -1 Then
			Pointer = Pointer +1
			GetRecord
		Else
			ToastMessageShow("No More Records, End Of File", False)
		End If
	Else
		ToastMessageShow("File Not Found Or No Records", False)
	End If
End Sub